//uniform vec4 LightPosition;

void main() {
	gl_Position = gl_ModelViewMatrix * gl_Vertex; // Vertex position in View space.
	
	vec3 N = normalize(gl_NormalMatrix * gl_Normal); // Vertex normal in View space.
	vec3 L = normalize((gl_LightSource[0].position - gl_Position).xyz); // Light vector in View space.
	vec3 V = normalize(-gl_Position.xyz); // View vector in View space.
	
	gl_TexCoord[0].x = max(dot(N, V), 0.0); // Perform edge detection.
	gl_TexCoord[0].y = dot(N, L); // Diffuse component.
	
	if (gl_TexCoord[0].y>0) {
		vec3 H = normalize(L + V); // Half vector in View space.
		gl_TexCoord[0].z = pow(max(dot(N, H), 0.0), 40);
	}
	else {
		gl_TexCoord[0].y = 0.0; gl_TexCoord[0].z = 0.0;
	}
	gl_Position = gl_ProjectionMatrix * gl_Position; // Vertex position in Screen space.
}